\section{The Courtemanche cell model}
\label{sec:Courtemanche}

In the atria, we the use the Courtemanche cell
model~\cite{courtemanche}.  Here, the model involves the ion
concentration of calcium $\text{Ca}$, $\text{Ca}_\text{up}$,
$\text{Ca}_\text{rel}$ , sodium $\text{Na}$, and potassium $\text{K}$,
and 15 gating variables
    \begin{align*}
      w
      =\big(
      \text{Ca},\text{Ca}_\text{up},\text{Ca}_\text{rel},\text{Na},\text{K},
      m,h,j,o_\text{a},o_\text{i},u_\text{a},u_\text{i},x_\text{r},x_\text{s},
      d,f,f_\text{Ca},u,v,w_\text{rel}\big)
      \,,
    \end{align*}
and it depends on the constants  
$g_\text{Na}$, $g_\text{CaL}$, $V_\text{CaL}$, $g_\text{Ks}$, $g_\text{to}$, $g_\text{Kr}$,
$V_\text{Kr1}$, $V_\text{Kr2}$,
 $g_\text{K1}$, $V_\text{K1}$,  $I_\text{NaCa(max)}$, $\text{Ca}_\text{e}$, 
 $\text{Na}_\text{e}$, $K_\text{m,Na(e)}$, $K_\text{m,Ca}$, 
 $k_\text{sat}$, $\gamma$, $F$, $R$, $T$, $I_\text{NaK(max)}$,
 $K_\text{m,Na}$, $\text{K}_\text{e}$, $K_{\text{m,K}_\text{e}}$,  
 $I_\text{p,Ca(max)}$, $g_\text{bCa}$, $K_\text{Q10}$ and $g_\text{bNa}$ for ionic currents and the constants
$V_\text{i}$, $\text{Ca}_\text{up,max}$, $k_\text{up}$, $k_\text{rel}$, $I_\text{up(max)}$,
 $\text{Trpn}_\text{max}$, $\text{Cmdn}_\text{max}$, $\text{Csqn}_\text{max}$, 
 $K_\text{m,Csqn}$, $K_\text{m,Cmdn}$, $K_\text{m,Trpn}$,
cf.~Tab.~\ref{tab:Courtemanche}.

In the equation for the potential
$ C_\text{m} \partial_t V_\text{m}=   I_\text{ion}(V_\text{m},w) + I_\text{ext}$,
the transmembrane current density $I_\text{ion}$ given by
    \begin{align*}
      I_\text{ion}(V_\text{m},w)
      &=I_\text{Na}(V_\text{m},\text{Na},m,h,j)
      +I_\text{CaL}(V_\text{m},d,f,f_\text{Ca})
      +I_\text{Ks}(V_\text{m},\text{K},x_\text{s})
      +I_\text{to}(V_\text{m},\text{K},o_\text{a},o_\text{i})\\
      &\qquad\qquad
      +I_\text{Kr}(V_\text{m},\text{K},x_\text{r})
      +I_\text{Kur}(V_\text{m},\text{K},u_\text{a},u_\text{i})
      +I_\text{K1}(V_\text{m},\text{K})+I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})\\
      &\qquad\qquad
      +I_\text{NaK}(V_\text{m},\text{Na})
      +I_\text{pCa}(\text{Ca})
      +I_\text{bCa}(V_\text{m},\text{Ca})
      +I_\text{bNa}(V_\text{m},\text{Na})
    \end{align*}
combines the contribution of different ions, where
    \begin{align*}
      I_\text{Na}\big(V_\text{m},\text{Na},m,h,j\big)
      &= g_\text{Na}m^3hj\big(V_\text{m}-E_\text{Na}(\text{Na})\big)
      \,,\\
      I_\text{CaL}(V_\text{m},d,f,f_\text{Ca})
      &= g_\text{CaL}dff_\text{Ca}\big(V_\text{m} - V_\text{CaL}\big)
      \,,\\
      I_\text{Ks}(V_\text{m},\text{K}, x_\text{s})
      &=
      g_\text{Ks}x_\text{s}^2\big(V_\text{m}-E_\text{K}(\text{K})\big)
     \,,\\
      I_\text{to}(V_\text{m},\text{K},o_\text{a},o_\text{i})
      &=
      g_\text{to}o_\text{a}^3o_\text{i}\big(V_\text{m}-E_\text{K}(\text{K})\big)
      \,,\\
      I_\text{Kr}(V_\text{m},\text{K},x_\text{r})
      &=
      \frac{g_\text{Kr} x_\text{r}\big(V_\text{m}-E_\text{K}(\text{K}\big)}{1+\text{exp}\Big(\big(V_\text{m}+V_\text{Kr1}\big)/V_\text{Kr2}\Big)}
      \,,\\
      I_\text{K1}(V_\text{m},\text{K})
      &=
      \frac{g_\text{K1}(V_\text{m}-E_\text{K}(\text{K})}{1+\text{exp}\big(0.07(V_\text{m}+V_\text{K1})\big)}
     \,,\\
      I_\text{Kur}(V_\text{m},\text{K},u_\text{a},u_\text{i})
      &=
      g_\text{Kur}u_\text{a}^3u_\text{i}\big(V_\text{m}-E_\text{K}(\text{K})\big)
      \,,\\
      I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      &=
      \frac{I_\text{NaCa(max)}\big(\exp(\gamma\frac{V_\text{m}F}{RT}))\text{Na}^3
        \text{Ca}_\text{e} - \exp((\gamma -1)\frac{V_\text{m}F}{RT})\text{Na}_\text{e}^3\text{Ca}\big)}{(K_\text{m,Na(e)}^3+\text{Na}_\text{e}^3 )(K_\text{m,Ca}+ \text{Ca}_\text{e})(1+k_\text{sat}\exp((\gamma-1)V_\text{m}\frac{F}{RT}))} 
      \,,\\
      I_\text{NaK}(V_\text{m},\text{Na})
      &=
      I_\text{NaK(max)} f_\text{NaK}\frac{1}{1+(K_\text{m,Na}/ \text{Na})^{1.5}}\frac{\text{K}_\text{e}}{\text{K}_\text{e}+K_{\text{m,K}_\text{e}}} 
      \,,\\
      I_\text{pCa}(\text{Ca})
      &=
      I_\text{p,Ca(max)}\frac{\text{Ca}}{0.0005+\text{Ca}} 
      \,,\\
      I_\text{bCa}(V_\text{m},\text{Ca})
      &=
      g_\text{bCa}\big(V_\text{m}-E_\text{Ca}(\text{Ca})\big)
      \,,\\
      I_\text{bNa}(V_\text{m},\text{Na})
      &=
      g_\text{bNa}\big(V_\text{m}-E_\text{Na}(\text{Na})\big)      
      % \,,
      % \\
      % I_\text{bK}(V_\text{m},\text{K})
      % &= g_\text{bK} \big(V_\text{m} - E_\text{K}(V_\text{m},\text{K})\big)
    \end{align*}
with the reverse potentials 
    \begin{align*}
      E_\text{Ca}(\text{Ca})
      &= \frac{RT}{zF}\log \frac{\text{Ca}_\text{e}}{\text{Ca}}
      \,,\\
      E_\text{Na}(\text{Na})
      &= \frac{RT}{zF}\log \frac{\text{Na}_\text{e}}{\text{Na}}
      \,,\\
      E_\text{K}(\text{K})
      &= \frac{RT}{zF}\log \frac{\text{K}_\text{e}}{\text{K}}
      \,.
    \end{align*}

\Paragraph{The evolution of ion concentration}

We have 
    \begin{align*}
      \partial_t \text{Na}
      &= -\frac{1}{V_\text{i}F}
      \Big(
      I_\text{Na}(V_\text{m},\text{Na},m,h,j)
      +I_\text{bNa}(V_\text{m},\text{Na})
      +3I_\text{NaK}(V_\text{m},\text{Na})
      +3I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      \Big)
      \,,
      \\
      \partial_t \text{K}
      &= -\frac{1}{V_\text{i}F}
      \Big(
      I_\text{K1}(V_\text{m},\text{K})
      +I_\text{to}(V_\text{m},\text{K},o_\text{a},o_\text{i})
      +I_\text{Kr}(V_\text{m},\text{K},x_\text{r})
      \\
      &\qquad\qquad\qquad
      +I_\text{Ks}(V_\text{m},\text{K},x_\text{s})
      -2I_\text{NaK}(V_\text{m},\text{Na})
      +I_\text{Kur}(V_\text{m},\text{K},u_\text{a},u_\text{i})
      %+I_\text{bK}(V_\text{m},\text{K})
      \Big)\,,
      \\
      \partial_t \text{Ca}
      &= \Big(-\frac{I_\text{bCa}(V_\text{m},\text{Ca})
      +I_\text{pCa}(\text{Ca})
      +I_\text{CaL}(V_\text{m},d,f,f_\text{Ca})
      -2I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})}{2V_\text{i}F}
      \\
      &\qquad\qquad
      +\frac{V_\text{up}(I_\text{up,leak}-I_\text{up}) + I_\text{rel}V_\text{rel}}{V_\text{i}}
      \Big)
      \Big(1 + \frac{\text{Trpn}_\text{max} K_\text{m,Trpn}}{(\text{Ca} +K_\text{m,Trpn})^2 }
      + \frac{\text{Cmdn}_\text{max} K_\text{m,Cmdn}}{(\text{Ca} +K_\text{m,Cmdn})^2}
      \Big)^{-1}\,,
      \\
      \partial_t \text{Ca}_\text{up}
      &= 
      I_\text{up}(\text{Ca})
      -I_\text{up,leak}(\text{Ca}_\text{up} )
      -I_\text{tr}(\text{Ca}_\text{up}, \text{Ca}_\text{rel})\frac{V_\text {rel}}{V_\text{up}}
      \,,
      \\
      \partial_t \text{Ca}_\text{rel}
      &=
      \Big(I_\text{tr}(\text{Ca}_\text{up},\text{Ca}_\text{rel})-I_\text{rel}(\text{Ca},\text{Ca}_\text{rel},u,v,w_\text{rel})\Big)
      \Big(1+\frac{\text{Csqn}_\text{max} K_\text{m,Csqn}}{(\text{Ca}_\text{rel} + K_\text{m,Csqn})^2}
      \Big)^{-1}
    \end{align*}
with 
    \begin{align*}
      I_\text{up}(\text{Ca})
      &= \frac{I_\text{up(max)}}{1+\frac{k_\text{up}}{\text{Ca}}}\,,\\
      I_\text{up,leak}(\text{Ca}_\text{up})
      &= \frac{\text{Ca}_\text{up}}{\text{Ca}_\text{up,max}}I_\text{up(max)}
      \,,\\
      I_\text{tr}(\text{Ca}_\text{up}, \text{Ca}_\text{rel})
      &=\frac{\text{Ca}_\text{up}-\text{Ca}_\text{rel}}{180}
      \,,\\
      I_\text{rel}(\text{Ca},\text{Ca}_\text{rel},u,v,w_\text{rel})
      &= k_\text{rel}u^2vw_\text{rel}\big(\text{Ca}_\text{rel}-\text{Ca}\big)
      \,.
    \end{align*}
    
\Paragraph{The gating evolution in the Courtemanche model}

For the evolution of the gating variables we specify every component
of $w$ independently.  Every gating variable $y
\in\big\{m,h,j,o_\text{a},o_\text{i},u_\text{a},u_\text{i},x_\text{r},x_\text{s},d,f,f_\text{Ca},
u,v,w_\text{rel}\big\}$ is described by a Hodgkin-Huxley type equation as given in
\eqref{eq:gatingDifferentialgleichung}, so that the evolution is determined by
$\tau_y$ and $y_\infty$, cf.~Sect.~\ref{sec:TenTusscher}.  As in the cell model
of ten Tusscher all expressions depending on $V_\text{m}$ are given in
mV, i.e., in $\exp\big((V_\text{m}+80)/6.8\big)$ the qualities 80 and
6.8 have the physical unit mV.

Here, we use for the gating variables
$\big\{m,h,j\big\}$ 
      \begin{align*}
      \tau_y(V_\text{m})
      &=\frac{1}{a_y (V_\text{m}) + b_y (V_\text{m})}
      \,,
        \\
      y_{\infty}(V_\text{m})
        &=
        a_y (V_\text{m})b_y (V_\text{m}),
     \end{align*} 
with
     \begin{align*}
      a_m (V_\text{m})
        &=\begin{cases}
        3.2& V_\text{m}= -47.13\,, \\ 
        0.32 \frac{V_\text{m}+ 47.13}{1-\exp\big(-0.1(47.13+V_\text{m})\big)} & \text{else}\,,
        \end{cases}        
        \\
      b_m(V_\text{m})
      &= 0.08\exp\Big( -\frac{V_\text{m}}{11}\Big)\,,
     \end{align*} 

     \begin{align*}
        a_h(V_\text{m})
        &=\begin{cases}0& V_\text{m}\geq -40\,, \\ 
        0.135\exp\big(-(V_\text{m}+80)/6.8\big) & \text{else}\,,
        \end{cases}        
        \\
        b_h(V_\text{m})
        &= \begin{cases}
          \displaystyle
          \Big( 0.13\big(1+\exp\big(-(10.66+V_\text{m})/11.1 \big) \big)  \Big)^{-1}&V_\text{m}\geq -40\,,
          \\ 
          3.56\exp(0.079V_\text{m})+3.1 \cdot 10^5 \exp(0.35V_\text{m}) & \text{else}\,,
        \end{cases}
     \end{align*} 
and
     \begin{align*}
        a_j(V_\text{m})
        &=
        \begin{cases}0 & V_\text{m}\geq -40 \,,\\
          \displaystyle
          \frac{\big(-127.14\exp(0.2444V_\text{m})- 3.474 \cdot 10^{-5} \exp(-0.04391V_\text{m})\big)(37.78+V_\text{m})}
          {1+\exp\big(  0.311(79.23+V_\text{m}\big)}\,,
        \end{cases}
        \\
        b_j(V_\text{m})
        &=
        \begin{cases}
          \displaystyle
          0.3\frac{\exp(-2.535\cdot 10^{-7} V_\text{m})}{1+\exp(-0.1(V_\text{m}+32))}& V_\text{m}\geq -40\,,
          \\
          &\\
          \displaystyle
          0.1212\frac{\exp(-0.01052 V_\text{m})}{1+\exp(-0.1378(V_\text{m}+40.14))} & \text{else}\,,
        \end{cases}
        \end{align*}
For the gating variables
$\big\{o_\text{a},o_\text{i},u_\text{a},u_\text{i},x_\text{r},x_\text{s},d,f,w_\text{rel}\big\}$ we use   
        \begin{align*}
        \tau_{o_\text{a}}(V_\text{m})
          &=
          \Big(K_\text{Q10}(\frac{0.65}{\exp(-(10+V_\text{m})/8.5)+\exp(-(-30+V_\text{m})/59)}+ \frac{0.65}{2.5+\exp((82+V_\text{m})/17)})\Big)^{-1}
          \,,\\
          o_{\text{a},\infty}(V_\text{m})
          &=
          \Big(1+\exp(-(20.47+V_\text{m})/17.54)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}         
         \tau_{o_\text{i}}(V_\text{m})
            &=
          \Big(K_\text{Q10}(\frac{1}{18.53 + \exp((113.7+V_\text{m})/10.95)}+ \frac{1}{35.56+\exp(-(1.26+V_\text{m})/7.44)})\Big)^{-1}
          \,,\\
          o_{\text{i},\infty}(V_\text{m})
          &=
          \Big(1+\exp((43.1+V_\text{m})/5.3)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}          
          \tau_{u_\text{a}}(V_\text{m})
          &=
          \tau_{o_\text{a}}(V_\text{m})
          \,,\\
          u_{\text{a},\infty}(V_\text{m})
          &=
          \Big(1+\exp(-(30.3+V_\text{m})/9.6)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}
          \tau_{u_\text{i}}(V_\text{m})
          &=
          \Big(K_\text{Q10}(\frac{1}{21 + \exp(-(-185+V_\text{m})/28)}+ \exp((-158+V_\text{m})/16))\Big)^{-1}
          \,,\\
          u_{\text{i},\infty}(V_\text{m})
          &=
          \Big(1+\exp((-99.45+V_\text{m})/27.48)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}          
          \tau_{x_\text{r}}(V_\text{m})
          &=
          \Big(0.0003\frac{14.1 + V_\text{m}}{1 - \exp(-(14.1+V_\text{m})/5)}
          +7.3898\cdot 10^{-5}\frac{-3.3328 + V_\text{m}}{\exp((-3.3328+V_\text{m})/5.1237)-1}\Big)^{-1}
          \,,\\
          x_{\text{r},\infty}(V_\text{m})
          &=
          \Big(1+\exp(-(14.1+V_\text{m})/6.5)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}          
          \tau_{x_\text{s}}(V_\text{m})
          &=
          0.5\Big(4\cdot 10^{-5}\frac{-19.9 + V_\text{m}}{1 - \exp(-(-19.9+V_\text{m})/17)}
          +3.5\cdot 10^{-5}\frac{-19.9 + V_\text{m}}{\exp((-19.9+V_\text{m})/9)-1}\Big)^{-1}
          \,,\\
          x_{\text{s},\infty}(V_\text{m})
          &=
          \Big(1+\exp(-(-19.9+V_\text{m})/12.7)\Big)^{-\frac{1}{2}}
          \,,
     \end{align*} 

     \begin{align*}          
          \tau_d(V_\text{m})
          &=
          \frac{1-\exp(-(10 + V_\text{m})/6.24)}{0.035 \big(10 + V_\text{m}\big)\big( 1+ \exp(-(10 + V_\text{m})/6.24) \big)}
          \,,\\
          d_{\infty}(V_\text{m})
          &=
         \Big(1+\exp\big(-(10+V_\text{m})/8\big)\Big)^{-1}
         \,,
     \end{align*} 

     \begin{align*}         
          \tau_f(V_\text{m})
          &=
          \frac{9}{0.0197\exp\big(  -0.0337^2(10+V_\text{m})^2\big)+0.02}
          \,,\\
          f_{\infty}(V_\text{m})
          &=
         \Big(1+\exp\Big((28+V_\text{m})/6.9\Big)\Big)^{-1}
          \,,
     \end{align*} 

     \begin{align*}
          \tau_{w_\text{rel}}(V_\text{m})
          &=
          6\frac{1-\exp\big(-(-7.9+V_\text{m})/5\big)}{\big(-7.9+ V_\text{m}\big)\big(1+0.3\exp\big(-(-7.9+V_\text{m})/5\big)\big)}
          \,,\\
          w_{\text{rel},\infty}(V_\text{m})
          &=
           1- \Big(1+\exp\Big(-(-40 + V_\text{m})/17\Big)\Big)^{-1}
          \,.
     \end{align*}
For the gating variables $\big\{u,v\big\}$ we use
          \begin{align*}
          \tau_{u}
          &=
          8
          \,,\\
          u_{\infty}(V_\text{m},\text{Na},d,f,f_\text{Ca})
          &=
          \Big(1+\exp\Big(\frac{F_\text{n}(V_\text{m},\text{Na},d,f,f_\text{Ca})
            -3.4175 \cdot 10^{-13}}{13.67 \cdot 10^{-16}}\Big)\Big)^{-1}
          \,,\\[15pt]
          \tau_{v}(V_\text{m},\text{Na},d,f,f_\text{Ca})
          &=
          1.91+2.09\Big( 1+ \exp\Big( - \frac{F_\text{n}(V_\text{m},\text{Na},d,f,f_\text{Ca}) - 3.4175 \cdot 10^{-13}}{13.67 \cdot 10^{-16}}\Big)  \Big)^{-1}
          \,,\\
          v_{\infty}(V_\text{m},\text{Na},d,f,f_\text{Ca})
          &=
            1-\Big(1+\exp\Big(\frac{F_\text{n}(V_\text{m},\text{Na},d,f,f_\text{Ca})-6.835 \cdot 10^{-14}}{13.67 \cdot 10^{-16}}\Big)\Big)^{-1}
          \,,
          \end{align*}
with
         \begin{equation*}
	   F_\text{n}(V_\text{m},\text{Na},d,f,f_\text{Ca})
           = 10^{-12}V_\text{rel} I_\text{rel} - \frac{5\cdot10^{-13}}{F}
           \Big(0.5       I_\text{CaL}(V_\text{m},d,f,f_\text{Ca})
           - 0.2I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})\Big)
	 \end{equation*}
and the function
	 \begin{align*}
	   g_\text{Kur} (V_\text{m}) = 0.005 + \frac{0.05}{1+\exp(-(-15+V_\text{m})/13)}.
	 \end{align*}
Finally, the evolution of the gating variable $f_\text{Ca}$ is also 
given by a Hodgkin-Huxley type equation, depending on~$\text{Ca}$. We have			
    \begin{align*}	
      \tau_{f_\text{Ca}}
      &=
      2
      \,,\\
      f_{\text{Ca},\infty}(\text{Ca})
      &=
      \Big(1+\frac{\text{Ca}}{0.00035}\Big)^{-1}
      \,.
    \end{align*}
    
